<template>
  <SinglePane :class="[ 'tender', { 'with-compact-header': isCompactHeader } ]">
    <template v-if="tenderInfo">
      <div
        ref="tenderHeaderWrapper"
        class="tender-header-wrapper"
      >
        <div
          ref="tenderHeader"
          :class="[ 'tender-header', { 'fixed': isCompactHeader } ]"
        >
          <div :class="[ 'tender-heading', { 'compact': isCompactHeader } ]">
            <div class="tender-info">
              <router-link
                class="icon chevron-left tender-back-button"
                :to="{ path: '/tenders', query: { ...this.$route.query } }"
              />

              <div class="tender-name">
                <span class="tender-code">{{ tenderInfo.number }}</span>

                {{ tenderInfo.title }}

                <sup :class="{ 'draft': tenderInfo.status === 'DRAFT' }">
                  {{ tenderStatusTitle }}
                </sup>
              </div>
            </div>

            <div class="tender-actions">
              <TenderMenu @reload-tender="createdMethods" />

              <ObButton
                v-if="button"
                type="primary-success"
                class="tender-main-action"
                :label="button.label"
                :disabled="isButtonDisabled"
                :mini="isCompactHeader"
                @click="onButtonClick"
              />
            </div>
          </div>

          <div
            v-show="!isCompactHeader"
            class="tender-data"
          >
            <div
              v-if="tenderInfo.transportationTypeTitle"
              class="tender-data-item"
            >
              {{ tenderFormData.transportationTypeTitle }}
            </div>

            <div
              v-if="tenderInfo.vatTitle"
              class="tender-data-item"
            >
              {{ `₽ ${tenderFormData.vatTitle}` }}
            </div>

            <div
              v-if="isTenderFinishedDtShown"
              class="tender-data-item right-aligned"
              title="Часовой пояс: Москва"
            >
              Дата окончания сбора: <span class="cap">{{ parseFinishDate(tenderInfo.targetFinishDt) }}</span>
              <span class="tender-timezone"> UTC+3</span>
            </div>
          </div>

          <ObAlert
            v-if="!tender.offers && tenderInfo.status === 'SUMMARIZING' && currentRole === 'client'"
            :hide-close-button="true"
            theme="warning"
            icon="alert"
          >
            По данному тендеру нет ни одного предложения. Пожалуйста,
            завершите текущий тендер и создайте новый с измененными параметрами.
          </ObAlert>

          <ObTabs
            v-model="selectedTab"
            :class="[ 'tabs-container', selectedTab ? `tab-${selectedTab.name}` : '' ]"
            :items="filteredTabs"
            :no-border="isCompactHeader"
            @on-change-tab="onChangeTab"
          />
        </div>
      </div>

      <div
        v-if="selectedTab"
        class="selected-tab"
      >
        <keep-alive>
          <component
            :is="'tab-' + selectedTab.name"
            :tender="tenderInfo"
            @changeTab="onChangeTab"
            @reloadTender="createdMethods"
          />
        </keep-alive>
      </div>

      <ObModal
        ref="publish-modal"
        title="Публикация тендера"
        size="medium"
        ok-text="Опубликовать"
        :isShowControls="true"
        @submit="onPublishModalConfirm"
      >
        <div class="modal-tender-text">{{ publishWarning }}</div>
      </ObModal>

    </template>
    <ObLoader
      v-else
      :size="60"
      class="tender-loader"
    />
  </SinglePane>
</template>

<script>
  import ClickOutside from 'vue-click-outside'
  import moment from 'moment'
  import { mapActions, mapGetters } from 'vuex'
  import api from '@/api'
  import { STATUSES } from '../statuses'
  import TenderMenu from '../components/tenderMenu'

  import SinglePane from 'common-components/src/obComponents/obSinglePanels'
  import ObButton from 'common-components/src/obComponents/obButton'
  import ObTabs from 'common-components/src/obComponents/obTabs'
  import ObModal from 'common-components/src/obComponents/obModal'
  import ObLoader from 'common-components/src/obComponents/obLoader'
  import ObAlert from 'common-components/src/obComponents/obAlert'

  import TabLots                  from './tabs/buyer/lots.vue'
  import TabCommon                from './tabs/buyer/common.vue'
  import TabParticipants          from './tabs/buyer/participants.vue'
  import TabBuyerStages           from './tabs/buyer/stages.vue'
  import TabRfqOffers             from './tabs/buyer/offers/rfq.vue'
  import TabRfiOffers             from './tabs/buyer/offers/rfi.vue'
  import TabScenarios             from './tabs/buyer/scenarios.vue'
  import TabRfqSummary            from './tabs/buyer/summary/rfq.vue'
  import TabRfiSummary            from './tabs/buyer/summary/rfi.vue'
  import TabBuyerQuestionnaire    from './tabs/buyer/questionnaire.vue'
  import TabBuyerTopics           from './tabs/buyer/topics.vue'
  import TabInfo                  from './tabs/carrier/info.vue'
  import TabCarrierLots           from './tabs/carrier/lots.vue'
  import TabCarrierQuestionnaire  from './tabs/carrier/questionnaire.vue'
  import TabCarrierStages         from './tabs/carrier/stages.vue'
  import TabCarrierTopics         from './tabs/carrier/topics.vue'

  export default {
    name: 'tender-index',
    directives: {
      ClickOutside
    },
    components: {
      SinglePane,
      ObButton,
      ObTabs,
      ObModal,
      ObLoader,
      ObAlert,
      TenderMenu,
      TabLots,
      TabCommon,
      TabParticipants,
      TabBuyerStages,
      TabCarrierStages,
      TabInfo,
      TabCarrierLots,
      TabBuyerQuestionnaire,
      TabCarrierQuestionnaire,
      TabRfqOffers,
      TabRfiOffers,
      TabScenarios,
      TabRfqSummary,
      TabRfiSummary,
      TabBuyerTopics,
      TabCarrierTopics
    },
    computed: {
      ...mapGetters({
        tender: 'tenders/tender',
        tenderInfo: 'tenders/tenderInfo',
        tenderFormData: 'tenders/tenderFormData',
        button: 'tenders/button',
        isButtonDisabled: 'tenders/isButtonDisabled',
        currentRole: 'tenders/currentRole',
        isScenarioWinnerExists: 'tenders/isScenarioWinnerExists'
      }),
      uuid: ({ $route }) => $route.params.uuid,
      tabs () {
        return [
          {
            title: 'Общие данные',
            name: 'common',
            users: ['client'],
            types: ['RFQ', 'RFI'],
            statuses: 'all',
            qa: 'tender-tab-common',
            id: 1
          },
          {
            title: 'Информация о тендере',
            name: 'info',
            users: ['carrier'],
            types: ['RFQ', 'RFI'],
            statuses: 'all',
            qa: 'tender-tab-info',
            id: 2
          },
          {
            title: 'Лоты',
            tabButtonHtml: this.getTabHtml('Лоты', this.tender.lots),
            name: 'lots',
            users: ['client'],
            types: ['RFQ'],
            statuses: 'all',
            qa: 'tender-tab-lots',
            id: 3
          },
          {
            title: 'Лоты',
            name: 'carrier-lots',
            users: ['carrier'],
            types: ['RFQ'],
            statuses: 'all',
            qa: 'tender-tab-carrier-lots',
            id: 4
          },
          {
            title: 'Анкета',
            name: 'buyer-questionnaire',
            users: ['client'],
            types: ['RFI'],
            statuses: 'all',
            qa: 'tender-tab-buyer-questionnaire',
            id: 5
          },
          {
            title: 'Анкета',
            name: 'carrier-questionnaire',
            users: ['carrier'],
            types: ['RFI'],
            statuses: 'all',
            qa: 'tender-tab-carrier-questionnaire',
            id: 6
          },
          {
            title: 'Участники',
            tabButtonHtml: this.getTabHtml('Участники', this.tender.participants),
            name: 'participants',
            users: ['client'],
            types: ['RFQ', 'RFI'],
            statuses: 'all',
            qa: 'tender-tab-participants',
            id: 7
          },
          {
            title: 'Предложения',
            tabButtonHtml: this.getTabHtml('Предложения', this.tender.offers),
            name: 'rfq-offers',
            users: ['client'],
            types: ['RFQ'],
            statuses: ['HELD', 'SUMMARIZING', 'COMPLETED', 'ARCHIVED'],
            qa: 'tender-tab-rfq-offers',
            id: 8
          },
          {
            title: 'Предложения',
            tabButtonHtml: this.getTabHtml('Предложения', this.tender.offers),
            name: 'rfi-offers',
            users: ['client'],
            types: ['RFI'],
            statuses: ['HELD', 'SUMMARIZING', 'COMPLETED', 'ARCHIVED'],
            qa: 'tender-tab-rfi-offers',
            id: 9
          },
          {
            title: 'Сценарии',
            name: 'scenarios',
            users: ['client'],
            types: ['RFQ'],
            statuses: ['SUMMARIZING', 'COMPLETED', 'ARCHIVED'],
            qa: 'tender-tab-scenarios',
            id: 10
          },
          {
            title: 'Итоги',
            name: 'rfq-summary',
            users: ['client'],
            types: ['RFQ'],
            statuses: ['COMPLETED', 'ARCHIVED'],
            qa: 'tender-tab-rfq-summary',
            id: 11
          },
          {
            title: 'Итоги',
            tabButtonHtml: this.getTabHtml('Итоги', this.tender.winners),
            name: 'rfi-summary',
            users: ['client'],
            types: ['RFI'],
            statuses: ['COMPLETED', 'ARCHIVED', 'SUMMARIZING'],
            qa: 'tender-tab-rfi-summary',
            id: 12
          },
          {
            title: 'Другие этапы',
            tabButtonHtml: this.getTabHtml('Другие этапы', this.stagesCount),
            name: 'buyer-stages',
            users: ['client'],
            types: ['RFQ'],
            statuses: 'all',
            qa: 'tender-tab-buyer-stages',
            isHidden: this.stagesCount === 0,
            id: 13
          },
          {
            title: 'Другие этапы',
            tabButtonHtml: this.getTabHtml('Другие этапы', this.stagesCount),
            name: 'carrier-stages',
            users: ['carrier'],
            types: ['RFQ'],
            statuses: 'all',
            qa: 'tender-tab-carrier-stages',
            isHidden: this.stagesCount === 0,
            id: 14
          },
          {
            title: 'Доп. информация, вопросы и ответы',
            tabButtonHtml: this.getTopicsTabHtml(),
            name: 'buyer-topics',
            users: ['client'],
            types: ['RFQ', 'RFI'],
            statuses: ['HELD', 'SUMMARIZING', 'COMPLETED', 'ARCHIVED'],
            qa: 'tender-tab-buyer-topics',
            id: 15
          },
          {
            title: 'Доп. информация, вопросы и ответы',
            tabButtonHtml: this.getTopicsTabHtml(),
            name: 'carrier-topics',
            users: ['carrier'],
            types: ['RFQ', 'RFI'],
            statuses: ['HELD', 'SUMMARIZING', 'COMPLETED', 'ARCHIVED'],
            qa: 'tender-tab-carrier-topics',
            id: 16
          }
        ]
      },
      filteredTabs: ({ tabs, currentRole, tenderInfo }) => tabs.filter(tab =>
        tab.users.includes(currentRole) &&
        tab.types.includes(tenderInfo.type) &&
        (tab.statuses === 'all' || tab.statuses.includes(tenderInfo.status))
      ),
      isTenderFinishedDtShown: ({ tenderInfo }) => tenderInfo.targetFinishDt && ['HELD'].includes(tenderInfo.status),
      tenderStatusTitle: ({ tenderInfo }) => STATUSES[tenderInfo.status],
      publishWarning: ({ tenderInfo }) => {
        let text;

        if (tenderInfo.type === 'RFQ') {
          text = 'После публикации вы больше не сможете изменить таблицу лотов или удалить участников, а выбранным вами контрагентам будет направлено приглашение принять участие в тендере.'
        } else {
          text = 'После публикации вы больше не сможете изменить анкету или удалить участников, а выбранным вами контрагентам будет направлено приглашение принять участие в тендере.'
        }

        return text;
      }
    },
    data () {
      return {
        moment,
        selectedTab: null,
        isCompactHeader: false,
        isAnimationPending: false,
        compactHeaderBreakpointHeight: null,
        stagesCount: 0
      }
    },
    watch: {
      '$route.params.tab': {
        handler: function (newTab) {
          this.selectedTab = this.tabs.find(tab => tab.name === newTab)
        },
        immediate: true
      }
    },
    created () {
      this.createdMethods();
    },
    beforeDestroy () {
      document.removeEventListener('scroll', this.handleScroll)
    },
    methods: {
      ...mapActions({
        getTender: 'tenders/getTender',
        updateTenderInfo: 'tenders/updateTenderInfo',
        publishTender: 'tenders/publishTender',
        setCurrentUserRole: 'tenders/setCurrentUserRole',
        resetTender: 'tenders/resetTender'
      }),
      handleScroll () {
        if (this.isAnimationPending) {
          return
        }

        window.requestAnimationFrame(() => {
          this.isCompactHeader = window.scrollY >= this.compactHeaderBreakpointHeight

          this.isAnimationPending = false
        })

        this.isAnimationPending = true
      },
      async createdMethods() {
        this.resetTender()
        this.setCurrentUserRole()

        const { type } = await api.tenders.getTenderTypeByUuid(this.uuid)

        await this.getTender({ type, uuid: this.uuid })

        if (this.tenderInfo.type === 'RFQ') {
          const { total_elements } = await api.tenders.getStages(this.uuid)

          this.stagesCount = total_elements - 1 // Exclude current stage
        }

        document.title = `Тендер - ${this.tenderInfo.title}`

        /* Compact header animation handler */

        this.compactHeaderBreakpointHeight = this.$refs.tenderHeader.offsetTop + this.$refs.tenderHeader.clientHeight
        this.$refs.tenderHeaderWrapper.style.minHeight = `${this.$refs.tenderHeader.clientHeight}px`

        document.addEventListener('scroll', this.handleScroll)
      },
      async onPublishModalConfirm () {
        await this.updateTenderInfo()

        const response = await this.publishTender()

        if (response?.error) {
          this.$notification({
            type: 'system_notification_error',
            message: `Ошибка: ${response.details}`
          })
        } else {
          this.$router.push({ path: '/tenders' })
        }
      },
      async onSendOffer () {
        if (this.tenderInfo.type === 'RFQ') {
          await api.tenders.sendTenderOfferByUuid(this.tender.offers[0])
        } else {
          await api.tenders.sendTenderFilledFormByUuids(this.tenderInfo.uuid, this.tender.filledForm.uuid)
        }

        this.$notification({
          type: 'snackbars',
          message: `Предложение отправлено`,
          timeout: 6000,
        });

        this.createdMethods();
      },
      // These methods call from vuex
      async onAcceptParticipation () {
        await api.tenders.acceptTenderParticipationByTypeAndUuid(this.tenderInfo.type, this.tenderInfo.uuid)

        await this.getTender({
          type: this.tenderInfo.type,
          uuid: this.tenderInfo.uuid,
          reset: true
        })
      },
      parseFinishDate(date) {
        return moment(date).locale('ru').format('LLLL')
      },
      getTabHtml (title, count) {
        return `${title} ${count ? `<span>${count}</span>` : ''}`
      },
      getTopicsTabHtml () {
        return `
          <div class="tab-topics">
            <i
              title="Если у вас есть вопросы по тендеру, можете задать их на этой странице.\nУчтите, что ваш вопрос и ответ клиента на него увидят все участники тендера"
              class="icon question"
            ></i>

            Доп. информация, вопросы и ответы
          </div>
        `
      },
      // 👂 Events
      onChangeTab (e) {
        this.$router.replace({
          ...this.$route,
          params: {
            ...this.$route.params,
            tab: this.filteredTabs.find(tab => tab.id === e.id).name
          }
        })
      },
      async onButtonClick () {
        switch (typeof this.button.action) {
          case 'function':
            await this.button.action()
            break

          case 'object': {
            switch (this.button.action.type) {
              case 'open-modal':
                this.$refs[this.button.action.refName].open()
                break

              case 'component-method':
                this[this.button.action.methodName]()
                break
            }

            break
          }
        }
      }
    }
  }
</script>

<style lang="scss">
  .ob_notification_container_action {
    color: $color-blue-navy-blue;
    cursor: pointer;
  }
</style>

<style lang="scss" scoped>
  @import "~common-components/src/assets/style/ob-style";
  @import "~common-components/src/static/css/mixins";

  .tender {
    --tender-header-offset: 0px;

    &.with-compact-header {
      --tender-header-offset: 95px;
    }
  }

  .tender-loader {
    margin: 8vh auto 0;
  }

  .tender-header-wrapper {
    z-index: 1000; // To show tender header over all other content
  }

  .tender-header {
    background-color: $background-white;
    transition: filter .3s ease-out;
    will-change: transform;
    top: 0;
    right: 20px;
    left: 20px;
    transform: translate3d(0, 0, 0);

    &.fixed {
      position: fixed;
      transition: transform .2s linear;
      transform: translate3d(0, var(--header-max-height), 0);
      filter: drop-shadow(0px 4px 16px rgba($blue-700, .2));
    }
  }

  .tender-heading {
    display: flex;
    justify-content: space-between;
    align-items: center;
    padding: 20px 20px 10px;

    &.compact {
      padding-bottom: 5px;

      .tender-code,
      .tender-name {
        font-size: 14px;
        line-height: 18px;
        font-weight: normal;
      }

      .tender-name {
        align-items: flex-end;
      }

      sup {
        font-size: 10px;
        line-height: 20px;
      }
    }
  }

  .tender-data {
    @include font-mixin(14px, 18px, 400, $color-text-base);

    padding: 0 20px 20px 55px;
    display: flex;
    align-items: flex-start;
    justify-content: flex-start;
  }

  .tender-data-item {
    margin-right: 40px;

    &.right-aligned {
      margin-left: auto;
    }

    &:last-child {
      margin-right: 0;
    }

    .cap {
      display: inline-block;

      &::first-letter {
        text-transform: uppercase;
      }
    }
  }

  .tender-timezone {
    color: $color-grey-span;
  }

  .tender-info {
    display: flex;
    max-width: 1000px;
    margin-right: 50px;
    align-items: center;
  }

  .tender-back-button {
    text-decoration: none;
    color: $color-blue-navy-blue;
    margin-right: 10px;
    font-size: 24px;
  }

  .tender-code {
    @include font-mixin(24px, 40px, 700, $color-grey-span);
  }

  .tender-name {
    @include font-mixin(24px, 40px, 700, $color-text-base);

    display: grid;
    grid-auto-flow: column;
    grid-column-gap: 10px;

    sup {
      @include font-mixin(10px, 20px, 400, $color-grey-span, 0.4px, uppercase);

      opacity: .8;

      &.draft {
        color: $color-error;
      }
    }
  }

  .tender-main-action {
    margin-left: 10px;
    transition: none; // To prevent animation when buttons becomes minified
  }

  .tender-actions {
    display: flex;
    align-items: center;
    position: relative;
    flex: none;
  }

  .modal-tender-text {
    @include font-mixin(16px, 20px, 400, $color-text-base);

    word-break: break-word;
  }

  .tabs-container {
    padding: 0 20px;

    &::v-deep {
      button > div span {
        color: $color-grey-label;
      }

      .tab-topics {
        display: grid;
        grid-auto-flow: column;
        align-items: center;
        grid-column-gap: 9px;
      }
    }
  }

  .selected-tab {
    height: 100%;
  }
</style>
